<!DOCTYPE html>
<html>

<head>
    <title>Quản lý bảng điểm</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <!-- User Data Table -->
    <div class="container">
        <div class="text-center my-4">
            <h2>Quản lý bảng điểm</h2>
        </div>
        <input type="button" class="btn btn-success form-group" value="Thêm User" id="btn-add-user" data-toggle='modal'
            data-target='#insert-user-modal'>
        <table class="table table-bordered table-striped table-hover text-center" id="user-table">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Name</th>
                    <th>Email</th>
                    <th>Message</th>
                    <th>CreateDate</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>
    </div>

    <!-- Create user modal -->
    <div id="insert-user-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Thêm User</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label for="name">Name:</label>
                        <input type="text" class="form-control" id="name" required>
                    </div>
                    <div class="form-group">
                        <label for="email">Email:</label>
                        <input type="email" class="form-control" id="email" required>
                    </div>
                    <div class="form-group">
                        <label for="message">Message:</label>
                        <textarea class="form-control" id="message" rows="3" required></textarea>
                    </div>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-success" id="btn-create-user">Thêm</button>
                    <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                </div>
            </div>
        </div>
    </div>

    <!-- Update user modal -->
    <div id="update-user-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Sửa User</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label for="update-name">Name:</label>
                        <input type="text" class="form-control" id="update-name" required>
                    </div>
                    <div class="form-group">
                        <label for="update-email">Email:</label>
                        <input type="email" class="form-control" id="update-email" required>
                    </div>
                    <div class="form-group">
                        <label for="update-message">Message:</label>
                        <textarea class="form-control" id="update-message" rows="3" required></textarea>
                    </div>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-primary" id="btn-update-user">Cập nhật</button>
                    <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                </div>
            </div>
        </div>
    </div>

    <!-- Delete confirm modal -->
    <div id="delete-user-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Xác nhận xóa User</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <p>Bạn có chắc chắn muốn xóa user này không?</p>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-danger" id="btn-confirm-delete-user">Xác nhận</button>
                    <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                </div>
            </div>
        </div>
    </div>

    <script>
        "use strict";

        // Khai báo biến mảng hằng số chứa danh sách tên các thuộc tính
        const gUSER_COLS = ["id", "name", "email", "message", "createDate", "action"];
        // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
        const gUSER_ID_COL = 0;
        const gUSER_NAME_COL = 1;
        const gUSER_EMAIL_COL = 2;
        const gUSER_MESSAGE_COL = 3;
        const gUSER_CREATE_DATE_TYPE_COL = 4;
        const gUSER_ACTION_COL = 5;
        // Khai báo DataTable & mapping collumns
        var gUserTable = $("#user-table").DataTable({
            columns: [
                { data: gUSER_COLS[gUSER_ID_COL] },
                { data: gUSER_COLS[gUSER_NAME_COL] },
                { data: gUSER_COLS[gUSER_EMAIL_COL] },
                { data: gUSER_COLS[gUSER_MESSAGE_COL] },
                { data: gUSER_COLS[gUSER_CREATE_DATE_TYPE_COL] },
                { data: gUSER_COLS[gUSER_ACTION_COL] },
            ],
            columnDefs: [
                {
                    targets: gUSER_ACTION_COL,
                    className: "text-center",
                    defaultContent: `
                    <button class="btn btn-primary btn-edit">Sửa</button>
                    <button class="btn btn-danger btn-delete" data-toggle='modal'>Xóa</button>
                    `
                }
            ],
            autoWidth: false
        });

        // Lấy ngày hiện tại theo định dạng dd/mm/yyyy
        function getCurrentDate() {
            const today = new Date();
            const day = today.getDate();
            const month = today.getMonth() + 1;
            const year = today.getFullYear();
            return `${day < 10 ? '0' + day : day}/${month < 10 ? '0' + month : month}/${year}`;
        }

        // Gọi API lấy danh sách user
        function getAllUsers() {
            $.ajax({
                url: "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/contacts",
                type: "GET",
                dataType: "json",
                success: function (res) {
                    gUserTable.clear().draw();
                    if (Array.isArray(res)) {
                        res.forEach(function (user) {
                            const createDate = user.createDate ? user.createDate : '';
                            const rowNode = gUserTable.row.add([
                                user.id,
                                user.name,
                                user.email,
                                user.message,
                                createDate,
                                ''
                            ]).draw().node();
                            $(rowNode).attr('data-user-id', user.id);
                        });
                    }
                },
                error: function (error) {
                    console.log(error.responseText);
                }
            });
        }


        // Thêm user
        function addUser(user) {
            $.ajax({
                url: "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/contacts",
                type: "POST",
                dataType: "json",
                data: user,
                success: function (res) {
                    getAllUsers();
                    $("#insert-user-modal").modal("hide");
                },
                error: function (error) {
                    console.log(error.responseText);
                }
            });
        }

        // Sửa user
        function updateUser(userId, user) {
            $.ajax({
                url: `https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/contacts/${userId}`,
                type: "PUT",
                dataType: "json",
                data: user,
                success: function (res) {
                    getAllUsers();
                    $("#update-user-modal").modal("hide");
                },
                error: function (error) {
                    console.log(error.responseText);
                }
            });
        }

        // Xóa user
        function deleteUser(userId) {
            $.ajax({
                url: `https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/contacts/${userId}`,
                type: "DELETE",
                dataType: "json",
                success: function (res) {
                    getAllUsers();
                    $("#delete-user-modal").modal("hide");
                },
                error: function (error) {
                    console.log(error.responseText);
                }
            });
        }

        // Hiển thị modal thêm user
        function showAddUserModal() {
            $("#insert-user-modal").modal("show");
        }

        // Hiển thị modal sửa user
        function showEditUserModal(userId) {
            const $modal = $("#update-user-modal");
            const $nameInput = $modal.find("#update-name");
            const $emailInput = $modal.find("#update-email");
            const $messageInput = $modal.find("#update-message");

            const $row = $(`#user-table tr[data-user-id="${userId}"]`);
            const name = $row.find("td:eq(" + gUSER_NAME_COL + ")").text();
            const email = $row.find("td:eq(" + gUSER_EMAIL_COL + ")").text();
            const message = $row.find("td:eq(" + gUSER_MESSAGE_COL + ")").text();

            $nameInput.val(name);
            $emailInput.val(email);
            $messageInput.val(message);

            $modal.modal("show");
        }

        // Hiển thị modal xác nhận xóa user
        function showDeleteUserModal(userId) {
            $("#btn-confirm-delete-user").attr("data-user-id", userId);
            $("#delete-user-modal").modal("show");
        }

        // Lấy thông tin user từ form
        function getUserFromForm() {
            const name = $("#name").val();
            const email = $("#email").val();
            const message = $("#message").val();
            const createDate = getCurrentDate();

            return {
                name: name,
                email: email,
                message: message,
                createDate: createDate
            };
        }

        // Lấy thông tin user từ form sửa
        function getUpdatedUserFromForm() {
            const name = $("#update-name").val();
            const email = $("#update-email").val();
            const message = $("#update-message").val();

            return {
                name: name,
                email: email,
                message: message
            };
        }

        // Gắn sự kiện click cho nút Thêm User
        $("#btn-add-user").click(function () {
            showAddUserModal();
        });

        // Gắn sự kiện click cho nút Thêm
        $("#btn-create-user").click(function () {
            const user = getUserFromForm();
            addUser(user);
        });

        // Gắn sự kiện click cho nút Sửa
        $("#btn-update-user").click(function () {
            const userId = $("#btn-update-user").attr("data-user-id");
            const user = getUpdatedUserFromForm();
            updateUser(userId, user);
        });

        // Gắn sự kiện click cho nút Xóa
        $("#btn-confirm-delete-user").click(function () {
            const userId = $("#btn-confirm-delete-user").attr("data-user-id");
            deleteUser(userId);
        });

        // Gắn sự kiện click cho nút Sửa User
        $("#user-table").on("click", ".btn-edit", function () {
            const userId = $(this).closest("tr").attr("data-user-id");
            showEditUserModal(userId);
        });

        // Gắn sự kiện click cho nút Xóa User
        $("#user-table").on("click", ".btn-delete", function () {
            const userId = $(this).closest("tr").attr("data-user-id");
            showDeleteUserModal(userId);
        });

        // Load danh sách user khi trang được tải
        getAllUsers();
    </script>
</body>

</html>